"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var nodeShape = {
  category: _propTypes["default"].string.isRequired,
  disabled: _propTypes["default"].bool,
  icon: _propTypes["default"].node,
  id: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]).isRequired,
  label: _propTypes["default"].node.isRequired,
  showCheckbox: _propTypes["default"].bool,
  title: _propTypes["default"].string,
  properties: _propTypes["default"].any
};

var nodeShapeWithChildren = _propTypes["default"].oneOfType([_propTypes["default"].shape(nodeShape), _propTypes["default"].shape(_objectSpread({}, nodeShape, {
  children: _propTypes["default"].arrayOf(nodeShape).isRequired
}))]);

var _default = nodeShapeWithChildren;
exports["default"] = _default;